﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace C_.Datastructures.Nodes.LinkedList
{
    internal class DoublyLinkedListNode<T> : INode<T>
    {
        public T? Value { get; set; } = default;
        public INode<T>? Next { get; set; } = default(DoublyLinkedListNode<T>);

        public INode<T>? Prev { get; set; } = default(DoublyLinkedListNode<T>);

        public static DoublyLinkedListNode<T> Create(T? value, DoublyLinkedListNode<T>? next, DoublyLinkedListNode<T> prev)
        {
            return new DoublyLinkedListNode<T>
            {
                Value = value,
                Next = next,
                Prev = prev
            };
        }
    }
}
